package ladasha.statistics;

import java.util.*;
import java.io.*;
import ladasha.io.*;

public class DiscreteRNG {
  
  private static DiscreteRNG instance = null;
  /*
  private static ArrayList<Double> probability;
  private static ArrayList<Double> distribution;
  */
  private static HashMap<Double,Double> probabilities;
  private static Logger logger = Logger.getInstance();
  
  public static DiscreteRNG getInstance() {
    logger.log("obtaining instance of DiscreteRNG");
    if (instance == null)
      instance = new DiscreteRNG();
    return instance;
  }
  
  private DiscreteRNG(){}
  
  /*
  public static void setProbability(ArrayList<Double> newProbability) {
    probability = newProbability;
  }
  
  public static void setDistribution(ArrayList<Double> newDistribution) {
  
  }
  */
  
  public static void setProbabilities(HashMap<Double,Double> newProbabilities) {
    logger.log("DiscreteRNG: setProbabilities(newProbabilities): setting new probabilites");
    probabilities = newProbabilities;
  }

  /*
  public double next() {
    Random r = new Random();
    double temp = r.nextDouble();
    for(Double d : probability) {
      if (temp <= d/1.0) {
        temp = distribution.get(probability.indexOf(d));
	      break;
      }
    }
    return temp;
  }
  */
  
  public static double next() {
    Random r = new Random();
    double temp = r.nextDouble();
    for(Double d : probabilities.keySet()) {
      if (temp <= probabilities.get(d)/1.0) {
        temp = d;
	      break;
      }
    }
    logger.log("DiscreteRNG: next(): returning " + temp);
    return temp;
  }
}

/*
class DiscreteTester {

	static DiscreteRNG d = DiscreteRNG.getInstance();
	static Scanner sc = new Scanner(System.in);
	static HashMap<Double,Double> probably = new HashMap<Double,Double>();

	static void prompt() {
		System.out.print("File name >");
		String s = sc.next();
		try {
	          sc = new Scanner(new FileInputStream(new File(s)));
		} catch (FileNotFoundException f) {}
		double running = 0.0;
		sc.useDelimiter(",");
		while (sc.hasNext()) {
		  double key = sc.nextDouble();
		  double value = sc.nextDouble();
		  running += value;
		  probably.put(key,value);
		}
		running = 0.0;
		for (Double d : probably.keySet()) {
		  running += probably.get(d);
		  probably.put(d,running);
		}
		DiscreteRNG.setProbabilities(probably);
		System.out.println("Total probability: " + running);
	}

	static void shoot() {
		for (int i = 0; i < 20; i++)
			System.out.println(DiscreteRNG.next());
	}
			

	public static void main(String[] args) {
		prompt();
		shoot();
	}
}
*/
